#!/usr/bin/python
# -*- coding: latin-1 -*-
#
#Datos: Todas las clases relacionadas con los datos, y sus correspondientes metodos

import tipos
import types


#Lista que guarda las variables

class Arrayvar(list):  #Extiendo las listas 
	def __init__(self):
		list.__init__(self)
	def obtenerindice(self,nombre):
		"""Obtiene el indice de un determinado tipo, ya sea por el nombre o por el objeto en si"""
		if nombre.__class__==types.StringType:
			for iter in self:   #Recorro buscando el elemento que tenga el nombre #range self esta mal
				if iter.nombre == nombre:
					return self.index(iter)
			return False
		else: #Vamos a comparar el objeto
			if nombre in self:
				return self.index(nombre)
			return False

#Contenedor de registros y variables
class contenedorregvar:
	def __init__(self):
		self.datos=[] #Un array para datos
		self.vars=Arrayvar() #Un array de variables 
	def __getitem__(self,indice): #Acceso por []
		"""Devuelve el item segun un indice numerico, un nombre, o un objeto variable
			Si es un indice, se entiende que se quiere acceder a un registro
			Si es un nombre o el objeto variable, se entiende que se quiere acceder a la columna
		"""
		if indice.__class__==types.IntType:
			return self.datos[indice]
		else:
			return self.get_col(indice)
			
	def __setitem__(self,indice,valor): #Modificacion por []
		if indice.__class__==types.IntType:
			self.datos[indice]=valor
		else: #Suponemos que indice es una variable, y que dato es una lista
			for registro in range(len(self.datos)):
				self.datos[registro][self.mat_var(indice)]=valor[registro]

	def get_dat(self,indice=-1):
		"""Devuelve un registro, por defecto el último"""
		return self.datos[indice]
	def get_var(self,indice):
		return self.vars[indice] 
	def set_var(self,indice,valor):
		self.vars[indice]=valor
	def get_col(self,indice):
		import tipos
		if indice.__class__==types.IntType:
			return [valor[indice] for valor in self.datos]
		elif indice.__class__==types.StringType or isinstance(indice,tipos.Tipo):
			return [valor[self.vars.obtenerindice(indice)] for valor in self.datos]
		else:
			return [valor[self.vars.obtenerindice(indice.latin1())] for valor in self.datos]
			
	def get_cel(self,x,y):
		"""Devuelve el valor de una sola celda"""
		# Si y es un numero,
		if y.__class__==types.IntType:
			return self.datos[x][y]
		elif y.__class__==types.StringType:
			return self.datos[x][self.vars.obtenerindice(y)]
		# Si y es una cadena, podria resolver la columna y calcular y
	def set_cel(self,x,y,valor):
		"""Cambia el valor de una sola celda""" #Deberia comprobar si la celda existe
		self.datos[x][y]=valor
	def num_dat(self):
		return len(self.datos)
	def num_var(self):
		return len(self.vars)
	def app_dat(self,dato=None):
		if dato: #Nos pasan la lista completa
			self.datos.append(dato)
		else: #Nos hacemos la lista nosotros con los valores por defecto
			array=[]
			for variable in range(self.num_var()): 
				array.append(self.get_var(variable).valorpordefecto)
			self.datos.append(array)

	def app_var(self,nombre=None,tipo="Entero",titulo=None,valores={},ancho=0,decimales=0,valorpordefecto=0):  
		"""Añade una variable de tipo tipo al array de variables. Ademas rellena los datos con el valor por defecto"""
		if not nombre:
			nombre="VAR"+str(self.num_var())
		if not titulo:
			titulo="Variable"+str(self.num_var())
		if nombre.__class__ == types.StringType:
			if tipo=="Entero":
				self.vars.append(tipos.Entero(nombre,titulo,valores,ancho,decimales,valorpordefecto)) #Cambiar los valores por defecto
		else:
			self.vars.append(nombre) # es un objeto variable enterio

		for i in range(self.num_dat()):
			self[i].append(valorpordefecto)
	def arr_tit(self):
		"""Devuelve una lista con todos los nombres de las variables"""
		return [tipo.nombre for tipo in self.vars]
	def arr_tit_bool(self):
		"""Devuelve una lista con todos los nombres de las variables Booleanas"""
		lista = [] 
		for tipo in self.vars:
			if tipo.tipo=="Booleano":
				lista.append(tipo.nombre)
		return lista
	def arr_var(self):
		"""Devuelve el array con todos los objetos de las variables"""
		return [tipo for tipo in self.vars]
	def mat_var(self,variable):
		"""A esta funcion se le pasa un objeto variable. Si esta existe en la lista de variables, se devuelve la posicion que ocupa (equivalente a index)"""
		return self.vars.obtenerindice(variable)
	def nom_var(self,variable):
		"""A esta funcion se le pasa un nombre. Si este existe en la lista de variables, se devuelve la ipropia variable"""
		return self.vars[self.vars.obtenerindice(variable)]

#Contenedor de lista de ficheros
class Listaficheros(list):
	def append(self,elemento):
		if elemento in self:
			self.remove(elemento)
		self.insert(0,elemento)


