from uiwdescriptivo import WidgetDescriptivo
from qt import *

#Este widget es el que representa las medidas descriptivas.
#Los eleementos que posee son:
#ListBox1: Donde se guarda el listado total de variables
#ListBox2: Listado de variables actualmente seleccionada
#pushButton1: Boton listado1 -> listado2
#pushButton2: Boton listado1 <- listado2
#pushButton3: Aceptar
#pushButton4: Cancelar


#checkBox1: Media?
#checkBox2: Varianza?

#Este widget tiene que conseguir enviar información a la interfaz de salida. Enviara lo siguiente:
# -Arrays de nombre de variables
# -Diccionario con las opciones



class WDescriptivo(WidgetDescriptivo):
		def __init__(self,parent = None,name = None,fl = 0):
			WidgetDescriptivo.__init__(self,parent,name,fl)
			self.__conexiones()
			self.seleccion=[] #La seleccion que ya se ha hecho. (Solo los nombres)
			self.dialogopadre=parent.parent().parent().parent()
			self.driza=parent.parent().parent().parent().parent().parent()


		def __conexiones(self):
			"""Bloque de conexiones del widget descriptivo"""
			self.connect(self.pushButton1,SIGNAL("clicked()"),self.__addelemento)
			self.connect(self.pushButton2,SIGNAL("clicked()"),self.__delelemento)
			self.connect(self.pushButton3,SIGNAL("clicked()"),self.__aceptar)

		#SLOTS
		def __aceptar(self):
			"""Aceptacion del dialogo"""
			#self.diccionario es el diccionario de opciones
			#if.exp("desc",self.diccionario(),self.seleccion)
			diccionario={"media":False,"varianza":False}
			if self.checkBox1.isChecked():
				diccionario["media"]=True
			if self.checkBox2.isChecked():
				diccionario["varianza"]=True
			self.driza.calcular("descriptivo",self.seleccion,diccionario)
			self.dialogopadre.accept()

		def show(self):
			self.__showcaja1()
			self.__showcaja2()
			WidgetDescriptivo.show(self)

		def __addelemento(self):
			#Obtener elemento de la seleccion de la lista1
			self.seleccion.append(self.listBox1.currentText())
			self.__showcaja1()
			self.__showcaja2()
		def __delelemento(self):
			#Obtener elemento de la seleccion de la lista1
			i=self.listBox2.currentItem()
			self.seleccion.remove(self.listBox2.currentText())
			self.__showcaja1()
			self.__showcaja2()
		def __showcaja1(self):
			self.listBox1.clear()
			i=0
			for var in self.driza.dato.arr_tit():
				if not var in self.seleccion:
					self.listBox1.insertItem(var,i)
					i+=1

		def __showcaja2(self):
			self.listBox2.clear()
			i=0
			for var in self.seleccion:
				self.listBox2.insertItem(var,i)
				i+=1

