#!/usr/bin/python
# -*- coding: latin-1 -*-

from qt import *
from qttable import *
from uivprincipal import vprincipal
from dcalculo import DCalculo
from dconfig import DConfig
from dfiltro import DFiltro
from dcrevar import DCrevar
from dgraficos import DGraficos
from dbuscar import DBuscar
from dcasos import DCasos

import sys
sys.path.append("./lib/")
sys.path.append("./dialog/vprincipal/")
import formatos
import string
import greytableitem

class VPrincipal(vprincipal):
	def __init__(self,parent): 
		"""Inicializador de la ventana principal"""
		import datos
		vprincipal.__init__(self,None)
		self.__conexiones()
		self.parentXXX=parent

		#Bloque de inicialización de dialogos
		self.dcalculo = DCalculo(self,"culo",0,)
		self.dfiltro = DFiltro(self,"dialogo filtrado",0,)
		self.dcrevar = DCrevar(self,"creacion variables",0,)
		self.dgraficos = DGraficos(self,"Graficos!",0,)
		self.dbuscar = DBuscar(self,"busqueda",0,)
		self.dconfig = DConfig(self,"Dialogo Config",0,)
		self.dcasos = DCasos(self,"Dialogo de casos",0,)



		#Bloque de variables de control (VARIABLES DE ESTADO)
		self.fichero = False  # Variable de control sobre si hay un fichero abierto. No sube a driza porque puede ser que otros dialogos abran otros ficheros
		self.modificado = False  # Variable de control sobre si el fichero abierto ha sido modificado


		#Variables enteras que almacenan el numero de casillas deseadas para las tablas como excedente

		self.nreg=10 
		self.nvar=10

		# Configuracion de la tabla de variables
		self.__inittablavar(self.nvar)
		self.table1.setSelectionMode(QTable.MultiRow)

	

		
		
	def parent(self):
		"""Funcion chorra para que funcione self.parent()"""
		return self.parentXXX

	def __conexiones(self):
		"""Funcion llamada en el constructor que almacena todas las conexiones accion-funcion"""
		self.connect(self.fileExitAction,SIGNAL("activated()"),self.__salirprograma)
		self.connect(self.archivoSalirAction,SIGNAL("activated()"),self.__salirprograma)
		self.connect(self.fileOpenAction,SIGNAL("activated()"),self.__abrirfichero)
		self.connect(self.fileSaveAsAction,SIGNAL("activated()"),self.__guardarcomo)
		self.connect(self.fileSaveAction,SIGNAL("activated()"),self.__guardar)
		self.connect(self.analizarMediaAction,SIGNAL("activated()"),self.__dialogoanalizar)
		self.connect(self.programaConfigurarAction,SIGNAL("activated()"),self.__configurar)
		self.connect(self.table1,SIGNAL("valueChanged(int,int)"),self.__actualizardat)
		self.connect(self.table2,SIGNAL("valueChanged(int,int)"),self.__actualizarvar)
		self.connect(self.datosFiltrarAction,SIGNAL("activated()"),self.__abrirdialogofiltro)
		self.connect(self.modificarCrear_nuevas_variablesAction,SIGNAL("activated()"),self.__dcrevar)
		self.connect(self.graficosBarrasAction,SIGNAL("activated()"),self.__dgraficos)
		self.connect(self.editFindAction,SIGNAL("activated()"),self.__dbuscar)
		self.connect(self.editCopyAction,SIGNAL("activated()"),self.copy)




	def __inittablavar(self,nvars):
		"""Inicializa la tabla de variables"""
		self.table2.setSelectionMode(QTable.MultiRow)
		self.table2.setNumRows(nvars)
		titulos=self.table2.horizontalHeader()
		titulos.setLabel (0,"Nombre")
		titulos.setLabel (1,"Tipo")
		titulos.setLabel (2,"Etiqueta")
		titulos.setLabel (3,"Valores")
		titulos.setLabel (4,"Ancho")
		titulos.setLabel (5,"Decimales")
		titulos.setLabel (6,"Valor por defecto")
		self.table2.setNumCols(7)
		for fila in range(self.table2.numRows()):
			self.table2.setItem(fila,3,self.__mixtotableitem())
			self.table2.setItem(fila,1,self.__combotableitem())		

	#Funciones Publicas
	def __showtablavar(self,pos=None):  
		""" Representa la variable pos en la tabla de variables. Las propiedades de la variable las lee de los datos.
		Si no se indica posicion, se entiende que se quiere rellenar toda la tabla
		"""
		if pos:
			if pos < self.parent().dato.num_var():
				self.table2.setItem(pos,1,self.__combotableitem())	
				self.table2.setText(pos,0,str(self.parent().dato.get_var(pos).nombre))
				self.table2.setText(pos,2,str(self.parent().dato.get_var(pos).titulo))
				self.table2.setText(pos,4,str(self.parent().dato.get_var(pos).ancho))
				self.table2.setText(pos,5,str(self.parent().dato.get_var(pos).decimales))
				self.table2.setText(pos,6,str(self.parent().dato.get_var(pos).valorpordefecto))
				self.table2.item(pos,1).setCurrentItem(self.parent().dato.get_var(pos).tipo)
				#Actualizacion de titulo en la tabla de datos
				titulos=self.table1.horizontalHeader()
				titulos.setLabel(pos,self.parent().dato.get_var(pos).titulo)
			else: 
				print("EEEEERRROOOORRRR") #excepcion!, se pide una variable que no existe
		else:
			for n in range(self.parent().dato.num_var()):
				self.table2.setItem(n,1,self.__combotableitem())	
				self.table2.setText(n,0,str(self.parent().dato.get_var(n).nombre))
				self.table2.setText(n,2,str(self.parent().dato.get_var(n).titulo))
				self.table2.setText(n,4,str(self.parent().dato.get_var(n).ancho))
				self.table2.setText(n,5,str(self.parent().dato.get_var(n).decimales))
				self.table2.setText(n,6,str(self.parent().dato.get_var(n).valorpordefecto))
				self.table2.item(n,1).setCurrentItem(self.parent().dato.get_var(n).tipo)


	def __showtabladat(self,pos=None):
		"""Muestra el dato en la posicion pos
		Lee de los datos, así que deben existir previamente
		Comprueba si esta filtrado o no para cambiar el color
		Si no se indica posicion, se entiende que se quiere rellenar toda la tabla
		"""
		if pos:  # se ha indicado la posicion
			if pos < self.parent().dato.num_dat():
				for i in range(self.parent().dato.num_var()):
					if self.parent().filtro:
						if self.parent().dato[self.parent().filtro][pos]:
							self.table1.setText(pos,i,str(self.parent().dato[pos][i]))
						else:
							self.table1.setItem(pos,i,greytableitem.GrisTableItem(self.table1,QTableItem.OnTyping,repr(self.parent().dato[pos][i]))) # el repr garantiza que sale una estring
					else:
						self.table1.setText(pos,i,str(self.parent().dato[pos][i]))
			else:
				print ("ERRRORRRRR") #excepcion
		else: # No se ha indicado la posicion, se rellena todo
			self.table1.setNumCols(self.parent().dato.num_var()+self.nvar)
			self.table1.setNumRows(self.parent().dato.num_dat()+self.nreg)
			#Este bucle puede ser optimizado, sacando el filtro.. #PENDIENTE
			for x in range(self.parent().dato.num_dat()):
				for y in range(self.parent().dato.num_var()):
					if self.parent().filtro:
						if self.parent().dato[self.parent().filtro][x]:
							self.table1.setText(x,y,str(self.parent().dato[x][y]))
						else:
							self.table1.setItem(x,y,greytableitem.GrisTableItem(self.table1,QTableItem.OnTyping,repr(self.parent().dato[x][y]))) # el repr garantiza que sale una estring
					else:
						self.table1.setText(x,y,str(self.parent().dato[x][y]))
			titulos=self.table1.horizontalHeader()
			i=0
			for nombre in self.parent().dato.arr_tit():
				titulos.setLabel(i,nombre)
				i=i+1


	
			

	#Funciones privadas
	def __combotableitem(self,indice=0):
		"""Devuelve un nuevo objeto tipo combotableitem"""
		lista=QStringList()
		import defaults
		for tipo in defaults.tipos():
			lista.append(tipo)
		return QComboTableItem(self.table2,lista)
	
	def __mixtotableitem(self):
		"""Devuelve un objeto mixto"""
		import buttontableitem
		lista = buttontableitem.buttontableitem(self.table2)
		return lista


	#Slots o como se llame

	def __salirprograma(self):
		qApp.exit(0)

	def __abrirfichero(self):
		""" Cuando pulsamos abrir un archivo """
		#if self.fichero: return
		filter=""
		for fmt in formatos.listar():
			filter=filter+"%s files (*.%s);;" % (fmt,string.lower(fmt))
		fn = QFileDialog.getOpenFileName(QString.null,filter,self,None,"Dialogo abrir fichero","")
		filename = str(fn)
		self.parent().cargarfichero(filename)
	
	def __guardar(self):
		if self.fichero:
			self.parent().guardarfichero()
		else:
			self.__guardarcomo()


	def __guardarcomo(self):
		fn = QFileDialog.getSaveFileName(QString.null,QString.null,self)
		filename = str(fn)
		if filename:
			self.parent().guardarfichero(filename)

	def __dialogoanalizar(self):
		self.dcalculo.show()

	def __configurar(self):
		self.dconfig.show()

	def __actualizardat(self,x,y):
		"""Actualiza los datos del objeto dato a partir de un cambio en la tabla de datos"""
		#Hay variables sin definir
		#Si estamos en una casilla que corresponde a una variable no creada
		if y>=self.parent().dato.num_var():
			for i in range(self.parent().dato.num_var(),y+1):
				self.parent().crearvariable()
				self.__showtablavar(i) # PENDIENTEdeberia mostrarlo todos

		#Si estamos en una casilla que corresponde a un registro no creado
		if x>=self.parent().dato.num_dat():
			#Actualizamos los valores intermedios(Si es que existe)
			
			for valoresintermedios in range (self.parent().dato.num_dat(),x):  
				self.parent().dato.app_dat()
				self.__showtabladat(valoresintermedios)

			#Actualizamos la fila que ha utilizado el usuario
			arrayaintroducir=[] #Tenemos que introducir un nuevo registro


			#REPENSAR ESTA PARTE
			for tipodato in range(self.parent().dato.num_var()): #PENDIENTE.. llamar tipodato a eso no tiene sentido
				if tipodato==y:
					arrayaintroducir.append(self.table1.text(x,y).latin1()) #Coge el dato que acaba de introducir
				else:
					valordefecto=self.parent().dato.get_var(tipodato).valorpordefecto
					arrayaintroducir.append(valordefecto) # Introduce el valor por defecto en el array
					self.table1.setText(x,tipodato,str(valordefecto)) # Introduce el valor en la tabla q se muestra
			self.parent().dato.app_dat(arrayaintroducir) #Introducir la celda + resto de valores por defecto
			#self.table1.setNumRows(self.table1.numRows()+1)

		#El valor introducido sobreescribe uno que ya existe
		else:
			self.parent().dato.set_cel(x,y,self.table1.text(x,y).latin1())
		
	def __actualizarvar(self,x,y):
		"""Funcion a que conecta con la introduccion de nuevos datos en la tabla de variables"""
		if x>=self.parent().dato.num_var(): #Es una nueva variable
			#Variables intermedias
			for valoresintermedios in range (self.parent().dato.num_var(),x):  
				self.parent().dato.app_var()
				self.__showtablavar(valoresintermedios)

			#Ultima variable
			self.parent().dato.app_var()
			variable=self.parent().dato.get_var()
			variable[y]=self.table2.text(x,y).latin1()
			self.__showtablavar(x)
		else: #Trabajamos sobre una variable ya existente
			if y==1:   # Alguien quiere cambiar el tipo
				import tipos
				textoencuestion=self.table2.text(x,y).latin1() 
				if textoencuestion == "Dinero":
					self.parent().dato.set_var(x,tipos.TDinero(self.parent().dato.get_var(x),self.parent().dato))
				elif textoencuestion == "Entero":
					self.parent().dato.set_var(x,tipos.TEntero(self.parent().dato.get_var(x),self.parent().dato))
				elif textoencuestion == "Booleano":
					self.parent().dato.set_var(x,tipos.TBooleano(self.parent().dato.get_var(x),self.parent().dato))
				self.show()  # Solucion provisional, no debería hacer falta actualizarlo TODO
			elif y==3: # Estamos en el caso de los casos, mejor no hacer nada ... de momento
				pass
			else:
				self.parent().dato.get_var(x)[y]=str(self.table2.text(x,y).latin1())

	def show(self):
		"""Esta funcion actualiza el contenido de las rejillas segun los datos
		Reimplementa el show de la clase base
		"""
		#Tabla de datos
		#El margen extra sugerido por las variables nvar y ndat
		self.__showtablavar()
		self.__showtabladat()
		#Titulo de datos
		vprincipal.show(self)



	def __abrirdialogofiltro(self):
		self.dfiltro.show()

	def __dcrevar(self):
		self.dcrevar.show()

	def __dgraficos(self):
		self.dgraficos.show()

	def __dbuscar(self):
		self.dbuscar.show()

	def __removeselection(self,tabla):
		""" Esta funcion borra la seleccion de la tabla"""
		for seleccion in range(tabla.numSelections()):
			tabla.removeSelection(seleccion)

	def copy(self):
		"""Esta funcion pega el contenido del clipboard en la tabla actual"""
		tablaactual=self.tabWidget2.currentPageIndex()
		cadena=""
		if tablaactual == 0:
			tabla=self.table1
		else:
			tabla=self.table2
		for seleccion in range(tabla.numSelections()):
			for fila in range(tabla.selection(seleccion).topRow(),tabla.selection(seleccion).bottomRow()+1):
				for columna in range(tabla.selection(seleccion).leftCol(),tabla.selection(seleccion).rightCol()+1):
					if tabla.item(fila,columna):
						cadena+=str(fila)+","+str(columna)+","+str(tabla.item(fila,columna).text())+" "
		cb = QApplication.clipboard()
		cb.setText(cadena)
		self.__removeselection(tabla)
#		Pendiente segun la seleccion
#		if cb.supportsSelection() :
#							cb.setText( self.__uri, QClipboard.Selection )

